
#include<stdio.h>


typedef struct {
	float x;
    float y;
} Point;


int PresekPravih(Point P, Point pp, Point Q, Point qq, Point *X);

main()
{
    Point X;
	int presek;
	Point P = {1.0, 1.0};  
	Point pp = {1.0, 0.0};
	Point Q = {2.0, 1.00001};
	Point qq = {5.0 , 0.0};
	presek = PresekPravih(P, pp, Q, qq, &X);
	if(presek == 1)
		printf("Presek pravih je tacka X(%4.2f , %4.2f).\n\n", X.x, X.y);
	else if(presek ==0)
		printf("Prave su paralelne.\n\n");
	else 
		printf("Prave se poklapaju\n\n");
	return 0;
}


int PresekPravih(Point P, Point pp, Point Q, Point qq, Point *X)
{ 
	const double epsilon2 = 0.000001;
	float s, pq2, dpqpp, dpqpp2;
	float pp2 = pp.x * pp.x + pp.y * pp.y;
	float qq2 = qq.x * qq.x + qq.y * qq.y;
	Point pq;
	pq.x = Q.x-P.x;
	pq.y = Q.y-P.y;
	float dppqq = pp.x * qq.y - pp.y * qq.x;
	float dppqq2 = dppqq * dppqq;
	if (dppqq2 > epsilon2 * pp2 * qq2){ // prave se seku
		s = (pq.x * pp.y - pq.y * pp.x)/dppqq;
		X->x  = Q.x + s * qq.x;
		X->y  = Q.y + s * qq.y;
		return 1;
	}
	// prave su paralelne ili se poklapaju
	pq2 = pq.x * pq.x + pq.y * pq.y;
	dpqpp = pq.x * pp.y - pq.y * pp.x;
	dpqpp2 = dpqpp * dpqpp;
	if (dpqpp2 > epsilon2 * pq2 * pp2){ // prave su paralelne
	return 0;
	}
	return 2;  	// prave se poklapaju
}
