
#include "afxwin.h"
#include "crtanje.h"

#define PI 3.141592

int main(int argc, char* argv[])
{
          // *********************************************
        	//      Crtanje elipse sa glavnim osama 5 i 3
     	// ***********************************************

  double a = 5;
  double b = 3;

  int nsteps = 30; //broj duzi kojima aproksimiramo elipsu

  double start, end;  // parametri za pocetak i kraj duzi
  Duz segment;   // duz koja aproksimira elipsu
  double eps = (2 * PI)/nsteps;  // interval (0, 2*PI) daje celu elipsu. Njega delimo na nsteps intervala duziene eps
  
  for (int i=0 ; i < nsteps; i++) {
    start = i * eps;  
	end = (i+1) * eps;
	segment.start.x = a * cos(start);  // parametrizacija elipse
	segment.start.y = b * sin(start);
	segment.end.x = a * cos(end);
	segment.end.y = b * sin(end);
	
	nacrtaj("proba", segment);
  }

	
 int err=0;
 
 err=prikazi("proba");
 
 if (err){
     printf("\n Greska u formatiranju!!! \n");
 }


return 0;
}
